'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onComplete = exports.onError = exports.onSuccess = exports.getRequestConfig = exports.isAxiosRequest = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getActionTypes = require('./getActionTypes');

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var isAxiosRequest = exports.isAxiosRequest = function isAxiosRequest(action) {
  return action.payload && action.payload.request;
};

var getRequestConfig = exports.getRequestConfig = function getRequestConfig(action) {
  return action.payload.request;
};

var onSuccess = exports.onSuccess = function onSuccess(_ref, options) {
  var action = _ref.action;
  var next = _ref.next;
  var response = _ref.response;
  var data = response.data;

  var responseMeta = _objectWithoutProperties(response, ['data']); // eslint-disable-line no-use-before-define


  var requestPayload = action.payload;
  var _action$meta = action.meta;
  var requestMeta = _action$meta === undefined ? {} : _action$meta;

  var restOfAction = _objectWithoutProperties(action, ['payload', 'meta']); // eslint-disable-line no-use-before-define

  var nextAction = _extends({}, restOfAction, {
    payload: data,
    meta: _extends({
      response: responseMeta
    }, requestPayload, requestMeta),
    type: (0, _getActionTypes.getActionTypes)(action, options)[1]
  });

  next(nextAction);
  return nextAction;
};

var onError = exports.onError = function onError(_ref2, options) {
  var action = _ref2.action;
  var next = _ref2.next;
  var error = _ref2.error;
  var requestPayload = action.payload;
  var requestMeta = action.meta;

  var restOfAction = _objectWithoutProperties(action, ['payload', 'meta']); // eslint-disable-line no-use-before-define


  var data = error.data;

  var restOfError = _objectWithoutProperties(error, ['data']); // eslint-disable-line no-use-before-define


  var nextAction = _extends({}, restOfAction, {
    error: data,
    meta: _extends({
      response: restOfError
    }, requestPayload, requestMeta),
    type: (0, _getActionTypes.getActionTypes)(action, options)[2]
  });

  next(nextAction);
  return nextAction;
};

var onComplete = exports.onComplete = function onComplete() {};